class Counter{
  int number; // whatever number is inside the counter
  String type; // Whether the counter is for youtubers or references
  String underText; // The text that goes under the counter
  float x; // the x coordinate (changes)
  float y; // the y coordinate (doesn't change)
  float d; // diameter
  float d2; // diameter of stroked circle
  int numConnections; // Number of connections for each channel
  
  String[] list; // list of strings to display
  
  float distX;
  float distY; 
  
  color c; // color pulled from rest of sketch
  String hexColor; // hex color string
  int intColor; // hex color converted to int
  int r;
  int g;
  int b;
  int speed; // speed of animation

  float stringX; // x coord of strings
  float stringX2; // second row of strings for long lists

  Counter(String temptype){
    type = temptype;
    y = 35;
    d = 30;
    d2 = d-2;
    numConnections = 0;
    underText = type;
    r = 88;
    g = 89;
    b = 91;
    speed = 15;
    distX = 0;
    distY = 0;
    stringX = -300;
    
  }

  void display(){
    
    hexColor = hex(c);
    intColor = unhex(hexColor);
    
    numConnections = 0;
    stringX2 = stringX + 160; // declare in display for animation
    
    if(type.equals("youtubers")){
      x = 35;
      if (anyClicked == false) { // Show overall counts on start
        number = channels.length;
        underText = type;
      } else { // switch to individual connections on detail view
        underText = "connections"; // change underText to connections
        for (int i = 0; i < channels.length; i++) {
          if (channelObjects[i].ifClicked == true) {
            for (int k = 0; k < connectionLines.size(); k++){
              Connection connection = connectionLines.get(k);
              if (connection.person1 == i) { 
                numConnections++;
              } 
              if (connection.person2 == i) {
                numConnections++;
              }
            } 
          }
        }
        number = numConnections;
      }
    } else if (type.equals("references")){
      x = 175;
      if (anyClicked == false) {
        number = 10; // replace with reference length once it's set up
      } else{
        number = 5; // replace with individual references once it's set up
      }
    }
    strokeWeight(1);
    ellipseMode(CENTER);
    fill (#ffffff);
    stroke(r, g, b);
    ellipse(x, y, d2, d2);
    fill(r, g, b);
    noStroke();
    ellipse(x, y, d, d);
    fill(darkGray);
    textFont(av12Font);
    textAlign(LEFT, CENTER);
    text(underText, x+d-5, y);
    textFont(av18Font);
    fill(#ffffff);
    textSize(14);
    textAlign(CENTER, CENTER);
    text(number, x, y);
    
    textFont(av12Font);
    textAlign(LEFT);
    fill(darkGray);
        
    if (cConnectString.size() <= 38) {
      for (int k = 0; k < cConnectString.size(); k++){
       String connectString = cConnectString.get(k);
       text(connectString, stringX, 100+(16*k));
      }
    } else {
      for (int k = 0; k < 38; k++){
       String connectString = cConnectString.get(k);
       text(connectString, stringX, 100+(16*k));
      }
      for (int k = 38; k < cConnectString.size(); k++){
       String connectString = cConnectString.get(k);
       text(connectString, stringX2, 100+(16*(k-38)));
      }
    
    }
    
    // NEW METHOD OF CHECK FOR HOVER
    distX = sq(x - mouseX);
    distY = sq(y - mouseY);
    if ((distX + distY) <= sq(d/2)){
      onHover();
    } else {
      offHover();
    }
    
  }

  void onHover() {
    // GET HOVER COLOR
    c = titleC;
    
    // Change background color to cyan on hover
      if (r > ((intColor >> 16) & 0xFF)) {
        r = r - speed;
      }
      if (r < ((intColor >> 16) & 0xFF)) {
        r = r + speed;
      }
      if (g > ((intColor >> 8) & 0xFF)) {
        g = g - speed;
      }
      if (g < ((intColor >> 8) & 0xFF)) {
        g = g + speed;
      }
      if (b > (intColor & 0xFF)) {
         b = b - speed;
      }
      if (b < (intColor & 0xFF)) {
         b = b + speed;
      }
    // Expand second circle behind
    if (d2 < 35) {
        d2 = d2 + (speed/5);
      }  
      
      if(type.equals("youtubers")){
        // animate strings in
        if (stringX < 25) {
          float stringDistX = stringX - 25;
          stringX = stringX - stringDistX/4;
        } 
      }
      
  }
  
  void offHover() {
    c = darkGray;

    // Change background color back to gray off hover
      if (r > ((intColor >> 16) & 0xFF)) {
        r = r - speed;
      }
      if (r < ((intColor >> 16) & 0xFF)) {
        r = r + speed;
      }
      if (g > ((intColor >> 8) & 0xFF)) {
        g = g - speed;
      }
      if (g < ((intColor >> 8) & 0xFF)) {
        g = g + speed;
      }
      if (b > (intColor & 0xFF)) {
         b = b - speed;
      }
      if (b < (intColor & 0xFF)) {
         b = b + speed;
      }
      // Hide stroked circle
      if (d2 > d-2) {
        d2 = d2 - (speed/5);
      }  
      
      if(type.equals("youtubers")){
        // animate strings out
        if (stringX > -300) {
          float stringDistX = stringX - 40;
          stringX = stringX + stringDistX/2;
        } 
      }

  }
  


}
